//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FontUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFontForm *FontForm;

TFontCharset charset[] = {
    ANSI_CHARSET,
    DEFAULT_CHARSET,
    SYMBOL_CHARSET,
    MAC_CHARSET,
    SHIFTJIS_CHARSET,
    HANGEUL_CHARSET,
    JOHAB_CHARSET,
    GB2312_CHARSET,
    CHINESEBIG5_CHARSET,
    GREEK_CHARSET,
    TURKISH_CHARSET,
    VIETNAMESE_CHARSET,
    HEBREW_CHARSET,
    ARABIC_CHARSET,
    BALTIC_CHARSET,
    RUSSIAN_CHARSET,
    THAI_CHARSET,
    EASTEUROPE_CHARSET,
    OEM_CHARSET,
};

USHORT prilang[] = {
LANG_NEUTRAL,
LANG_AFRIKAANS,
LANG_ALBANIAN,
LANG_ARABIC,
LANG_ARMENIAN,
LANG_ASSAMESE,
LANG_AZERI,
LANG_BASQUE,
LANG_BELARUSIAN,
LANG_BENGALI,
LANG_BULGARIAN,
LANG_CATALAN,
LANG_CHINESE,
LANG_CROATIAN,
LANG_CZECH,
LANG_DANISH,
LANG_DIVEHI,
LANG_DUTCH,
LANG_ENGLISH,
LANG_ESTONIAN,
LANG_FAEROESE,
LANG_FARSI,
LANG_FINNISH,
LANG_FRENCH,
LANG_GALICIAN,
LANG_GEORGIAN,
LANG_GERMAN,
LANG_GREEK,
LANG_GUJARATI,
LANG_HEBREW,
LANG_HINDI,
LANG_HUNGARIAN,
LANG_ICELANDIC,
LANG_INDONESIAN,
LANG_ITALIAN,
LANG_JAPANESE,
LANG_KANNADA,
LANG_KASHMIRI,
LANG_KAZAK,
LANG_KONKANI,
LANG_KOREAN,
LANG_KYRGYZ,
LANG_LATVIAN,
LANG_LITHUANIAN,
LANG_MACEDONIAN,
LANG_MALAY,
LANG_MALAYALAM,
LANG_MANIPURI,
LANG_MARATHI,
LANG_MONGOLIAN,
LANG_NEPALI,
LANG_NORWEGIAN,
LANG_ORIYA,
LANG_POLISH,
LANG_PORTUGUESE,
LANG_PUNJABI,
LANG_ROMANIAN,
LANG_RUSSIAN,
LANG_SANSKRIT,
LANG_SERBIAN,
LANG_SINDHI,
LANG_SLOVAK,
LANG_SLOVENIAN,
LANG_SPANISH,
LANG_SWAHILI,
LANG_SWEDISH,
LANG_SYRIAC,
LANG_TAMIL,
LANG_TATAR,
LANG_TELUGU,
LANG_THAI,
LANG_TURKISH,
LANG_UKRAINIAN,
LANG_URDU,
LANG_UZBEK,
LANG_VIETNAMESE,
};

USHORT sublang[] = {
SUBLANG_NEUTRAL,
SUBLANG_DEFAULT,
SUBLANG_SYS_DEFAULT,
SUBLANG_ARABIC_SAUDI_ARABIA,
SUBLANG_ARABIC_IRAQ,
SUBLANG_ARABIC_EGYPT,
SUBLANG_ARABIC_LIBYA,
SUBLANG_ARABIC_ALGERIA,
SUBLANG_ARABIC_MOROCCO,
SUBLANG_ARABIC_TUNISIA,
SUBLANG_ARABIC_OMAN,
SUBLANG_ARABIC_YEMEN,
SUBLANG_ARABIC_SYRIA,
SUBLANG_ARABIC_JORDAN,
SUBLANG_ARABIC_LEBANON,
SUBLANG_ARABIC_KUWAIT,
SUBLANG_ARABIC_UAE,
SUBLANG_ARABIC_BAHRAIN,
SUBLANG_ARABIC_QATAR,
SUBLANG_AZERI_LATIN,
SUBLANG_AZERI_CYRILLIC,
SUBLANG_CHINESE_TRADITIONAL,
SUBLANG_CHINESE_SIMPLIFIED,
SUBLANG_CHINESE_HONGKONG,
SUBLANG_CHINESE_SINGAPORE,
SUBLANG_CHINESE_MACAU,
SUBLANG_DUTCH,
SUBLANG_DUTCH_BELGIAN,
SUBLANG_ENGLISH_US,
SUBLANG_ENGLISH_UK,
SUBLANG_ENGLISH_AUS,
SUBLANG_ENGLISH_CAN,
SUBLANG_ENGLISH_NZ,
SUBLANG_ENGLISH_EIRE,
SUBLANG_ENGLISH_SOUTH_AFRICA,
SUBLANG_ENGLISH_JAMAICA,
SUBLANG_ENGLISH_CARIBBEAN,
SUBLANG_ENGLISH_BELIZE,
SUBLANG_ENGLISH_TRINIDAD,
SUBLANG_ENGLISH_ZIMBABWE,
SUBLANG_ENGLISH_PHILIPPINES,
SUBLANG_FRENCH,
SUBLANG_FRENCH_BELGIAN,
SUBLANG_FRENCH_CANADIAN,
SUBLANG_FRENCH_SWISS,
SUBLANG_FRENCH_LUXEMBOURG,
SUBLANG_FRENCH_MONACO,
SUBLANG_GERMAN,
SUBLANG_GERMAN_SWISS,
SUBLANG_GERMAN_AUSTRIAN,
SUBLANG_GERMAN_LUXEMBOURG,
SUBLANG_GERMAN_LIECHTENSTEIN,
SUBLANG_ITALIAN,
SUBLANG_ITALIAN_SWISS,
SUBLANG_KASHMIRI_INDIA,
SUBLANG_KOREAN,
SUBLANG_LITHUANIAN,
SUBLANG_MALAY_MALAYSIA,
SUBLANG_MALAY_BRUNEI_DARUSSALAM,
SUBLANG_NEPALI_INDIA,
SUBLANG_NORWEGIAN_BOKMAL,
SUBLANG_NORWEGIAN_NYNORSK,
SUBLANG_PORTUGUESE,
SUBLANG_PORTUGUESE_BRAZILIAN,
SUBLANG_SERBIAN_LATIN,
SUBLANG_SERBIAN_CYRILLIC,
SUBLANG_SPANISH,
SUBLANG_SPANISH_MEXICAN,
SUBLANG_SPANISH_MODERN,
SUBLANG_SPANISH_GUATEMALA,
SUBLANG_SPANISH_COSTA_RICA,
SUBLANG_SPANISH_PANAMA,
SUBLANG_SPANISH_DOMINICAN_REPUBLIC,
SUBLANG_SPANISH_VENEZUELA,
SUBLANG_SPANISH_COLOMBIA,
SUBLANG_SPANISH_PERU,
SUBLANG_SPANISH_ARGENTINA,
SUBLANG_SPANISH_ECUADOR,
SUBLANG_SPANISH_CHILE,
SUBLANG_SPANISH_URUGUAY,
SUBLANG_SPANISH_PARAGUAY,
SUBLANG_SPANISH_BOLIVIA,
SUBLANG_SPANISH_EL_SALVADOR,
SUBLANG_SPANISH_HONDURAS,
SUBLANG_SPANISH_NICARAGUA,
SUBLANG_SPANISH_PUERTO_RICO,
SUBLANG_SWEDISH,
SUBLANG_SWEDISH_FINLAND,
SUBLANG_URDU_PAKISTAN,
SUBLANG_URDU_INDIA,
SUBLANG_UZBEK_LATIN,
SUBLANG_UZBEK_CYRILLIC,
};

WORD sortid[] = {
SORT_DEFAULT,
SORT_JAPANESE_XJIS,
SORT_JAPANESE_UNICODE,
SORT_CHINESE_BIG5,
SORT_CHINESE_PRCP,
SORT_CHINESE_UNICODE,
SORT_CHINESE_PRC,
SORT_CHINESE_BOPOMOFO,
SORT_KOREAN_KSC,
SORT_KOREAN_UNICODE,
SORT_GERMAN_PHONE_BOOK,
SORT_HUNGARIAN_DEFAULT,
SORT_HUNGARIAN_TECHNICAL,
SORT_GEORGIAN_TRADITIONAL,
SORT_GEORGIAN_MODERN,
};
//---------------------------------------------------------------------------
__fastcall TFontForm::TFontForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFontForm::FontDialogButtonClick(TObject *Sender)
{
    if ( FontDialog->Execute() )
        MyFont = FontDialog->Font;
}
//---------------------------------------------------------------------------
void __fastcall TFontForm::DrawButtonClick(TObject *Sender)
{
    SetThreadLocale(MAKELCID(MAKELANGID(prilang[PriLangComboBox->ItemIndex],sublang[SubLangComboBox->ItemIndex]),sortid[SortIDComboBox->ItemIndex]));
    //SetThreadLocale(0x409);

    FontImage->Canvas->FillRect(FontImage->ClientRect);
    FontImage->Canvas->Font = MyFont;
    //FontImage->Canvas->Font->Name = "MS-DOS CP 437";
    FontImage->Canvas->Font->Charset = charset[CharSetComboBox->ItemIndex];
    //FontImage->Canvas->Font->Charset = 500;//
    FontImage->Canvas->Font->Height = FontHeightUpDown->Position;

    BYTE c[2] = {'a','\0'};
    for (int i=0; i<256; i++) {
        c[0] = i;
        FontImage->Canvas->TextOut((i&0xf)*32, (i>>4)*32, AnsiString((char*)c));
    }
}
//---------------------------------------------------------------------------
void __fastcall TFontForm::FormCreate(TObject *Sender)
{
    MyFont = new TFont();

    FontImage->Canvas->Brush->Color = clWhite;
    FontImage->Canvas->Brush->Style = bsSolid;
}
//---------------------------------------------------------------------------
void __fastcall TFontForm::AddFontResourceButtonClick(TObject *Sender)
{
    int ret = AddFontResource(FontFilenameEdit->Text.c_str());
    if (ret == 0) ShowMessage("damepo!");
}
//---------------------------------------------------------------------------
void __fastcall TFontForm::RemoveFontResourceButtonClick(TObject *Sender)
{
    RemoveFontResource(FontFilenameEdit->Text.c_str());
}
//---------------------------------------------------------------------------

